var fs = require('fs')
var save = require('file-save')
var resolve = require('path').resolve
var basename = require('path').basename
var localePath = resolve(__dirname, '../src/locale/lang')
var fileList = fs.readdirSync(localePath)

var transform = function(filename, name, cb) {
  require('babel-core').transformFile(resolve(localePath, filename), { moduleId: name }, cb)
}

fileList
  .filter(function(file) {
    return /\.js$/.test(file)
  })
  .forEach(function(file) {
    var name = basename(file, '.js')

    transform(file, name, function(err, result) {
      if (err) {
        console.error(err)
      } else {
        var code = result.code
        save(resolve(__dirname, '../lib/locale', file)).write(code)
        console.log(file)
      }
    })
  })
