import KtBreadCard from '@@/bread-card/index.js'
import KtBreadcrumb from '@@/breadcrumb/index.js'
import KtButton from '@@/button/index.js'
import KtCron from '@@/cron/index.js'
import KtDialog from '@@/dialog/index.js'
import KtFileUpload from '@@/file-upload/index.js'
import KtFormDialog from '@@/form-dialog/index.js'
import KtHumanVerify from '@@/human-verify/index.js'
import KtIcon from '@@/icon/index.js'
import KtImage from '@@/image/index.js'
import KtImageUpload from '@@/image-upload/index.js'
import KtInput from '@@/input/index.js'
import KtLoading from '@@/loading/index.js'
import MenuItem from '@@/menu-item/index.js'
import KtOrderDialog from '@@/order-dialog/index.js'
import KtPop from '@@/pop/index.js'
import KtPopForm from '@@/pop-form/index.js'
import KtPopMenu from '@@/pop-menu/index.js'
import KtProgressBar from '@@/progress-bar/index.js'
import KtQuery from '@@/query/index.js'
import KtSvgFormatter from '@@/svg-formatter/index.js'
import KtTable from '@@/table/index.js'
import KtTitleInput from '@@/title-input/index.js'
import KtTree from '@@/tree/index.js'
import KtTreeSelect from '@@/tree-select/index.js'
import KtUserPage from '@@/user-page/index.js'
import KtUserSelect from '@@/user-select/index.js'

import locale from '@/locale'

import * as color from '@/utils/color'
import * as validate from '@/utils/validate'
import formatSVG from '@/utils/svg-format/index.js'
import array2tree from 'smart-arraytotree'
import lodash from 'lodash'

const components = {
  KtBreadCard,
  KtBreadcrumb,
  KtButton,
  KtCron,
  KtDialog,
  KtFileUpload,
  KtFormDialog,
  KtHumanVerify,
  KtIcon,
  KtImage,
  KtImageUpload,
  KtInput,
  KtLoading,
  MenuItem,
  KtOrderDialog,
  KtPop,
  KtPopForm,
  KtPopMenu,
  KtProgressBar,
  KtQuery,
  KtSvgFormatter,
  KtTable,
  KtTitleInput,
  KtTree,
  KtTreeSelect,
  KtUserPage,
  KtUserSelect,
}

// 导出工具函数
export const utils = {
  ...color,
  ...validate,
  formatSVG,
  array2tree,
}

// 定义 install 方法，接收 Vue 作为参数
// 如果使用 use 注册插件，则所有的组件都将被注册
const install = function(Vue, opts = {}) {
  locale.use(opts.locale)
  locale.i18n(opts.i18n)
  Object.values(components).map(c => Vue.component(c.name, c))
}

// 支持使用cdn引入脚本时自动安装到当前环境
if (typeof window !== 'undefined' && window.Vue) {
  Vue.prototype._ = lodash
  window._ = lodash
  install(window.Vue)
}

export default {
  install,
  ...components,
}
